//---------------------------------------------------------------------------

#include <vcl.h>
#include "algostuff.hpp"

#include <conio.h> //  getch()

#pragma hdrstop

//---------------------------------------------------------------------------

#pragma argsused
using namespace std;

std::string ToRus(const std::string &in)
{
  char *buff = new char [in.length()+1];
  CharToOem(in.c_str(),buff);
  std::string out(buff);
  delete [] buff;
  return out;
}

bool isEven (int elem)
{
    return elem % 2 == 0;
}


int main()
{
  vector<int> coll;
  int num;

  INSERT_ELEMENTS(coll,1,9);
  PRINT_ELEMENTS(coll," :\n ");

    //     4
    num = count (coll.begin(), coll.end(),       // 
                 4);                             // 
    cout << ToRus(" ,  4:  ") << num << endl;

    //   
    num = count_if (coll.begin(), coll.end(),    // 
                    isEven);                     // 
    cout << ToRus("  :     ") << num << endl;

    //    ,  4
    num = count_if (coll.begin(), coll.end(),    // 
                    bind2nd(greater<int>(),4));  // 
    cout << ToRus(" ,  4: ") << num << endl;


  getch();
  return 0;
}

//---------------------------------------------------------------------------